<!doctype html>
<html lang="en">
<head>
<meta charset="utf-8">
<?php
/*
#########################################################
############   openPlaG 4.0: function.php   #############
#########################################################
#############   written by Juergen Kummer   #############
#########################################################
##############   published under GNU GPL   ##############
#########################################################
## Original source: https://rechneronline.de/openPlaG/ ##
#########################################################
Copyright (C) Juergen Kummer

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

/*
This file is the content of the iframe, where the image
of the graph is displayed. It is called by the main page
hosting the iframe and only contains the image.
*/

//avoid sql injection
function sqi($a) {
	if($a!=str_replace("sql","",$a))
		$a=0;
	return $a;
}
// get variables
$c=sqi($_POST['c']);
$formula1=sqi($_POST['formula1']);
$formula2=sqi($_POST['formula2']);
$formula3=sqi($_POST['formula3']);
$col1=sqi($_POST['col1']);
$col2=sqi($_POST['col2']);
$col3=sqi($_POST['col3']);
$term1=sqi($_POST['term1']);
$term2=sqi($_POST['term2']);
$term3=sqi($_POST['term3']);
$width=sqi($_POST['width']);
$height=sqi($_POST['height']);
$rulex1=sqi($_POST['rulex1']);
$rulex2=sqi($_POST['rulex2']);
$ruley1=sqi($_POST['ruley1']);
$ruley2=sqi($_POST['ruley2']);
$intervalsx=sqi($_POST['intervalsx']);
$intervalsy=sqi($_POST['intervalsy']);
$linex=sqi($_POST['linex']);
$liney=sqi($_POST['liney']);
$deci=sqi($_POST['deci']);
$mid=sqi($_POST['mid']);
$lines=sqi($_POST['lines']);
$numbers=sqi($_POST['numbers']);
$dashes=sqi($_POST['dashes']);
$frame=sqi($_POST['frame']);
$errors=sqi($_POST['errors']);
$sint1=sqi($_POST['sint1']);
$sint2=sqi($_POST['sint2']);
$sint3=sqi($_POST['sint3']);
$grid=sqi($_POST['grid']);
$gridx=sqi($_POST['gridx']);
$gridy=sqi($_POST['gridy']);
$logsk=sqi($_POST['logsk']);
$logski=sqi($_POST['logski']);//this variable will merge with $logsk
$ta1=sqi($_POST['ta1']);
$ta2=sqi($_POST['ta2']);
$tb1=sqi($_POST['tb1']);
$tb2=sqi($_POST['tb2']);
$tc1=sqi($_POST['tc1']);
$tc2=sqi($_POST['tc2']);
$cint1=sqi($_POST['cint1']);
$cint2=sqi($_POST['cint2']);
$cint3=sqi($_POST['cint3']);
$qq=sqi($_POST['qq']);
$bg=sqi($_POST['bg']);
$gapc=sqi($_POST['gapc']);
$capt=sqi($_POST['capt']);
$linec=sqi($_POST['linec']);
$con0=sqi($_POST['con0']);
$con1=sqi($_POST['con1']);
$con2=sqi($_POST['con2']);
$anti=sqi($_POST['anti']);
$gamma=sqi($_POST['gamma']);
$bri=sqi($_POST['bri']);
$cont=sqi($_POST['cont']);
$emb=sqi($_POST['emb']);
$blur=sqi($_POST['blur']);
$neg=sqi($_POST['neg']);
$gray=sqi($_POST['gray']);
$mean=sqi($_POST['mean']);
$edge=sqi($_POST['edge']);
$bf=sqi($_POST['bf']);
$pol=sqi($_POST['pol']);
$rotate=sqi($_POST['rotate']);
$filetype=sqi($_POST['filetype']);
$logskx=sqi($_POST['logskx']);
$logskix=sqi($_POST['logskix']);//this variable will merge with $logskx
$Y=sqi($_POST['Y']);
$selfcol0=sqi($_POST['selfcol0']);
$selfcol1=sqi($_POST['selfcol1']);
$selfcol2=sqi($_POST['selfcol2']);
$thick=sqi($_POST['thick']);
$mp1=sqi($_POST['mp1']);
$mp2=sqi($_POST['mp2']);
$mp3=sqi($_POST['mp3']);
$midc=sqi($_POST['midc']);

// first we need to alter the submitted values a bit
// and make some plausibility checks
$formula1=rawurlencode($formula1);
$formula2=rawurlencode($formula2);
$formula3=rawurlencode($formula3);
$qq=rawurlencode($qq);
$Y=rawurlencode($Y);
$width=abs(intval($width));
$height=abs(intval($height));
if (!$width || $width>500) $width=500;
if (!$height || $height>500) $height=500;
if ($width<200) $width=200;
if ($height<200) $height=200;
$rulex1=str_replace(",",".",$rulex1);
$rulex2=str_replace(",",".",$rulex2);
$ruley1=str_replace(",",".",$ruley1);
$ruley2=str_replace(",",".",$ruley2);
$gamma=str_replace(",",".",$gamma);
if ($rulex1>100000 || $rulex1 < -100000) $rulex1=-100000;
if ($rulex2>100000 || $rulex2 < -100000) $rulex2=100000;
if ($ruley1>100000 || $ruley1 < -100000) $ruley1=-100000;
if ($ruley2>100000 || $ruley2 < -100000) $ruley2=100000;
$intervalsx=abs(intval($intervalsx));
$intervalsy=abs(intval($intervalsy));
if($intervalsx>250) $intervalsx=250;
if($intervalsy>250) $intervalsy=250;
if($intervalsx>$width/2) $intervalsx=round($width/2);
if($intervalsy>$height/2) $intervalsy=round($height/2);
$gridx=abs(intval($gridx));
$gridy=abs(intval($gridy));
if($gridx>250) $gridx=250;
if($gridy>250) $gridy=250;
if($gridx>$width/2) $gridx=round($width/2);
if($gridy>$height/2) $gridy=round($height/2);
$linex=abs(intval($linex));
$liney=abs(intval($liney));
if($linex>500) $linex=500;
if($liney>500) $liney=500;
$deci=abs(intval($deci));
$mid=abs(str_replace(",",".",$mid));
if($deci>12) $deci=12;
if($mid>500) $mid=500;
if($logski) $logsk=$logski;
$logsk=str_replace(",",".",$logsk);
if($logsk==1) $logsk=0;
$bri=str_replace(",",".",$bri);
$rotate=str_replace(",",".",$rotate);
if($logskix) $logskx=$logskix;
$logskx=str_replace(",",".",$logskx);
if($logskx==1) $logskx=0;
if($thick>200) $thick=200;
if($thick<1) $thick=1;
$mp1=str_replace(",",".",$mp1);
$mp2=str_replace(",",".",$mp2);
$mp3=str_replace(",",".",$mp3);
$midc=abs(str_replace(",",".",$midc));

// change variable names to keep the query string short
// &z marks the end of the query string
$query="a0=".$c."&a1=".$formula1."&a2=".$formula2."&a3=".$formula3."&a4=".$col1."&a5=".$col2."&a6=".$col3."&a7=".$term1."&a8=".$term2."&a9=".$term3."&b0=".$width."&b1=".$height."&b2=".$rulex1."&b3=".$rulex2."&b4=".$ruley1."&b5=".$ruley2."&b6=".$intervalsx."&b7=".$intervalsy."&b8=".$linex."&b9=".$liney."&c0=".$deci."&c1=".$mid."&c2=".$lines."&c3=".$numbers."&c4=".$dashes."&c5=".$frame."&c6=".$errors."&c7=".$sint1."&c8=".$sint2."&c9=".$sint3."&d0=".$grid."&d1=".$gridx."&d2=".$gridy."&d3=".$logsk."&d4=".$ta1."&d5=".$ta2."&d6=".$tb1."&d7=".$tb2."&d8=".$tc1."&d9=".$tc2."&e0=".$cint1."&e1=".$cint2."&e2=".$cint3."&e3=".$qq."&e4=".$bg."&e5=".$gapc."&e6=".$capt."&e7=".$linec."&e8=".$con0."&e9=".$con1."&f0=".$con2."&f1=".$anti."&f2=".$gamma."&f3=".$bri."&f4=".$cont."&f5=".$emb."&f6=".$blur."&f7=".$neg."&f8=".$gray."&f9=".$mean."&g0=".$edge."&g1=".$bf."&g2=".$pol."&g3=".$rotate."&g4=".$filetype."&g5=".$logskx."&g6=".$Y."&g7=".$selfcol0."&g8=".$selfcol1."&g9=".$selfcol2."&h0=".$thick."&h1=".$mp1."&h2=".$mp2."&h3=".$mp3."&h4=".$midc."&z";
?>
<title></title>
<meta http-equiv="expires" content="0">
<meta http-equiv="cache-control" content="no-cache">
<meta name="robots" content="noindex,nofollow">
</head>
<body style="padding:0px;margin:0px;background-color:#f0ffff" onload="document.getElementById('back').style.backgroundImage='url(back.png)'">
<table border="0" cellspacing="0" cellpadding="0">
<tr><td id="back" style="width:500px;height:500px;text-align:center;vertical-align:middle">
<img src="graph.php?<?= $query ?>" width="<?= $width ?>" height="<?= $height ?>" alt="Graph">
</td></tr></table>
<script type="text/javascript">
parent.document.getElementById("path").value="<?= rawurldecode($query) ?>";
</script>
</body>
</html>